/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.io.Serializable;
import java.util.Comparator;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dto.MCodeDto;
import jp.mosp.system.vo.CodeMasterListVo;

/**
 * @author yoshida
 *
 */
public class CodeMasterListAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_CODE_LIST_SHOW		= "S2020";	// 表示
	private static final String	CMD_CODE_LIST_SEARCH	= "S2021";	// 検索
	private static final String	CMD_CODE_LIST_RE_SEARCH	= "S2022";	// 再検索
	private static final String	CMD_CODE_LIST_SORT		= "S2023";	// ソート
																	
	
	/**
	 * コンストラクタ
	 */
	public CodeMasterListAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_LIST_SHOW)) {
			// 表示処理
			show();
		} else if (cmd.equals(CMD_CODE_LIST_SEARCH)) {
			// 検索処理
			search();
		} else if (cmd.equals(CMD_CODE_LIST_RE_SEARCH)) {
			// 再検索
			research();
		} else if (cmd.equals(CMD_CODE_LIST_SORT)) {
			// ソート
			sortList(key1);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new CodeMasterListVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		// コード区分プルダウンリスト作成
		vo.aryPltTId = getMosPCodeArray();
	}
	
	@Override
	protected void show() throws Exception {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		// 検索履歴を初期値にセット
		vo.setSearchmode(CodeMasterListVo.SEARCH_OFF);
	}
	
	@Override
	protected void search() throws Exception {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		vo.setParams(request);
		searchCodeList();
		vo.setIsAscending(true);
		vo.initListInfo();
		// 検索履歴をありにセット
		vo.setSearchmode(CodeMasterListVo.SEARCH_ON);
	}
	
	@Override
	protected void research() throws Exception {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		if (vo.getSearchmode() == CodeMasterListVo.SEARCH_ON) {
			removeSessionDto();
			searchCodeList();
			vo.setPageButton();
			sortList();
		}
	}
	
	/**
	 * コードリスト検索
	 * @throws Exception   例外処理が発生した場合
	 */
	private void searchCodeList() throws Exception {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		// 検索
		vo.setFields(part().mospcode().getMCodeDao().findForSearch(vo.getPltTId(), vo.getTxtTCode(), vo.getTxtTName()));
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryTCode().length == 0) {
			vo.addErrMessage(getMessage(MospConst.MSG_NO_DATA, ""));
		}
	}
	
	@Override
	protected void sortList(String key) throws MospException {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		vo.sortList(key, getComparator(key));
		vo.setFields(vo.getList());
	}
	
	@Override
	protected void sortList() throws MospException {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		vo.sortList(getComparator(vo.getFormerKey()));
		vo.setFields(vo.getList());
	}
	
	@Override
	protected Comparator<Object> getComparator(String key) throws MospException {
		CodeMasterListVo vo = (CodeMasterListVo)getVo();
		Comparator<Object> comp = null;
		if (key.equals(vo.KEY_T_ID)) {
			comp = new CompTId();
		} else if (key.equals(vo.KEY_T_CODE)) {
			comp = new CompTCode();
		} else if (key.equals(vo.KEY_T_NAME)) {
			comp = new CompTName();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}
	

	/**
	 * コード名による比較クラス
	 */
	protected static class CompTId implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= 7210303772053153377L;
		

		public int compare(Object obj1, Object obj2) {
			MCodeDto dto1 = (MCodeDto)obj1;
			MCodeDto dto2 = (MCodeDto)obj2;
			return dto1.getTId().compareTo(dto2.getTId());
		}
	}
	
	/**
	 * コードによる比較クラス
	 */
	protected static class CompTCode implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= 5672044129524635759L;
		

		public int compare(Object obj1, Object obj2) {
			MCodeDto dto1 = (MCodeDto)obj1;
			MCodeDto dto2 = (MCodeDto)obj2;
			return dto1.getTCode().compareTo(dto2.getTCode());
		}
	}
	
	/**
	 * コード名称による比較クラス
	 */
	protected static class CompTName implements Comparator<Object>, Serializable {
		
		private static final long	serialVersionUID	= -8615320106870669507L;
		

		public int compare(Object obj1, Object obj2) {
			MCodeDto dto1 = (MCodeDto)obj1;
			MCodeDto dto2 = (MCodeDto)obj2;
			return dto1.getTName().compareTo(dto2.getTName());
		}
	}
	
}
